﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Xml.Serialization;

namespace XMLConfigReadWrite
{
    [Serializable]
    public class Config
    {
        public string demo = "true";

        // for the serializer
        public Config()
        {
        }

        public Config(string file)
        {
            this.file = file;
        }

        string file = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location) + @"\config.xml";

        public static Config Load()
        {
            return FromFile(System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetEntryAssembly().Location) + @"\config.xml");
        }

        public static Config FromFile(string file)
        {
            if (!File.Exists(file))
            {
                Config d = new Config(file);
                d.Save();
            }
            XmlSerializer xs = new XmlSerializer(typeof(Config));
            using (FileStream fs = new FileStream(file, FileMode.Open, FileAccess.Read, FileShare.Read))
            {
                return (Config)xs.Deserialize(fs);
            }
        }

        public void Save()
        {
            Save(file);
        }

        /// <summary>
        /// Write current config to file
        /// </summary>
        public void Save(string file)
        {
            XmlSerializer xs = new XmlSerializer(typeof(Config));
            using (FileStream fs = new FileStream(file, FileMode.Create, FileAccess.Write, FileShare.None))
            {
                xs.Serialize(fs, this);
            }
        }
    }
}
